blob: df25f1792923a65aab2c4ce88e7b528effb381f5 [file] [log] [blame]
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
Michal Sojka64b90322010-04-16 15:53:59 +02005# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070017
Johannes Schindelin44138552009-02-04 00:26:12 +010018# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
Johannes Schindelin3da93652009-02-04 00:26:26 +010024*' --tee '*|*' --va'*)
Johannes Schindelin44138552009-02-04 00:26:12 +010025 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
Junio C Hamanoc2116a12008-03-06 19:04:26 -080034# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070037# For repeatability, reset the environment to known value.
38LANG=C
Junio C Hamano899460f2005-10-09 21:58:02 -070039LC_ALL=C
Pavel Roskind9bdd392005-08-10 22:10:01 -040040PAGER=cat
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070041TZ=UTC
Junio C Hamanoc2116a12008-03-06 19:04:26 -080042TERM=dumb
43export LANG LC_ALL PAGER TERM TZ
Eric Wong8ff99e72006-07-11 12:01:54 -070044EDITOR=:
Jonathan Niederd33738d2009-11-11 17:56:07 -060045unset VISUAL
Josh Triplett28a94f82007-04-28 18:40:28 -070046unset EMAIL
Jonathan Nieder95a1d122011-03-15 05:10:45 -050047unset $(perl -e '
48 my @env = keys %ENV;
Jens Lehmann730477f2011-03-28 21:16:09 +020049 my $ok = join("|", qw(
50 TRACE
51 DEBUG
52 USE_LOOKUP
53 TEST
54 .*_TEST
55 PROVE
56 VALGRIND
57 ));
58 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
Jonathan Nieder95a1d122011-03-15 05:10:45 -050059 print join("\n", @vars);
60')
Junio C Hamano29e55cd2006-02-10 19:11:23 -080061GIT_AUTHOR_EMAIL=author@example.com
62GIT_AUTHOR_NAME='A U Thor'
Junio C Hamano29e55cd2006-02-10 19:11:23 -080063GIT_COMMITTER_EMAIL=committer@example.com
64GIT_COMMITTER_NAME='C O Mitter'
Shawn O. Pearce8d0fc482007-02-04 00:45:47 -050065GIT_MERGE_VERBOSITY=5
66export GIT_MERGE_VERBOSITY
Junio C Hamano29e55cd2006-02-10 19:11:23 -080067export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
Jonathan Niederd33738d2009-11-11 17:56:07 -060069export EDITOR
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070070
Junio C Hamano886a3902007-04-24 11:21:47 -070071# Protect ourselves from common misconfiguration to export
72# CDPATH into the environment
73unset CDPATH
74
Bert Wesarg5565f472009-11-18 17:15:19 +010075unset GREP_OPTIONS
76
Robin Rosenberg3d5c0cc2006-09-23 00:35:20 +020077case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
Christian Couder6ce4e612006-09-02 18:23:48 +020078 1|2|true)
79 echo "* warning: Some tests will not work if GIT_TRACE" \
80 "is set as to trace on STDERR ! *"
81 echo "* warning: Please set GIT_TRACE to something" \
82 "other than 1, 2 or true ! *"
83 ;;
84esac
85
Junio C Hamanocd3c0952009-09-20 11:10:14 -070086# Convenience
87#
88# A regexp to match 5 and 40 hexdigits
89_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
91
Junio C Hamano3749fde2011-04-23 22:34:13 -070092# Zero SHA-1
93_z40=0000000000000000000000000000000000000000
94
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070095# Each test should start with something like this, after copyright notices:
96#
97# test_description='Description of this test...
98# This test checks if command xyzzy does the right thing...
99# '
100# . ./test-lib.sh
Junio C Hamanoc2116a12008-03-06 19:04:26 -0800101[ "x$ORIGINAL_TERM" != "xdumb" ] && (
102 TERM=$ORIGINAL_TERM &&
103 export TERM &&
104 [ -t 1 ] &&
105 tput bold >/dev/null 2>&1 &&
106 tput setaf 1 >/dev/null 2>&1 &&
107 tput sgr0 >/dev/null 2>&1
108 ) &&
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200109 color=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700110
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700111while test "$#" -ne 0
112do
113 case "$1" in
114 -d|--d|--de|--deb|--debu|--debug)
115 debug=t; shift ;;
Junio C Hamano886856a2005-05-14 00:24:27 -0700116 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
117 immediate=t; shift ;;
Lea Wiemann5e2c08c2008-06-17 03:29:02 +0200118 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
Junio C Hamano91e80b92009-02-18 11:17:27 -0800119 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700120 -h|--h|--he|--hel|--help)
Michele Ballabio570f3222007-11-10 15:17:25 +0100121 help=t; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700122 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
123 verbose=t; shift ;;
Pierre Habouzit1ece1272007-10-24 22:03:39 +0200124 -q|--q|--qu|--qui|--quie|--quiet)
Ævar Arnfjörð Bjarmason092c4332010-07-31 16:40:05 +0000125 # Ignore --quiet under a TAP::Harness. Saying how many tests
126 # passed without the ok/not ok details is always an error.
127 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700128 --with-dashes)
129 with_dashes=t; shift ;;
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200130 --no-color)
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100131 color=; shift ;;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100132 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
Johannes Schindelin3da93652009-02-04 00:26:26 +0100133 valgrind=t; verbose=t; shift ;;
Johannes Schindelin44138552009-02-04 00:26:12 +0100134 --tee)
135 shift ;; # was handled already
Jeff Kingf423ef52009-08-09 04:39:45 -0400136 --root=*)
137 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
138 shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700139 *)
Clemens Buchacher1f729dc2009-06-01 14:14:40 +0200140 echo "error: unknown test option '$1'" >&2; exit 1 ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700141 esac
142done
143
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200144if test -n "$color"; then
145 say_color () {
Junio C Hamanoc2116a12008-03-06 19:04:26 -0800146 (
147 TERM=$ORIGINAL_TERM
148 export TERM
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200149 case "$1" in
150 error) tput bold; tput setaf 1;; # bold red
151 skip) tput bold; tput setaf 2;; # bold green
152 pass) tput setaf 2;; # green
153 info) tput setaf 3;; # brown
Pierre Habouzit1ece1272007-10-24 22:03:39 +0200154 *) test -n "$quiet" && return;;
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200155 esac
156 shift
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000157 printf "%s" "$*"
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200158 tput sgr0
Miklos Vajnab8eecaf2008-10-10 00:07:10 +0200159 echo
Junio C Hamanoc2116a12008-03-06 19:04:26 -0800160 )
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200161 }
162else
163 say_color() {
Pierre Habouzit1ece1272007-10-24 22:03:39 +0200164 test -z "$1" && test -n "$quiet" && return
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200165 shift
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000166 echo "$*"
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200167 }
168fi
169
170error () {
171 say_color error "error: $*"
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200172 GIT_EXIT_OK=t
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200173 exit 1
174}
175
176say () {
177 say_color info "$*"
178}
179
Michele Ballabio570f3222007-11-10 15:17:25 +0100180test "${test_description}" != "" ||
181error "Test script did not set test_description."
182
183if test "$help" = "t"
184then
185 echo "$test_description"
186 exit 0
187fi
188
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400189exec 5>&1
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700190if test "$verbose" = "t"
191then
192 exec 4>&2 3>&1
193else
194 exec 4>/dev/null 3>/dev/null
195fi
196
197test_failure=0
198test_count=0
Junio C Hamano41ac4142008-02-01 01:50:53 -0800199test_fixed=0
200test_broken=0
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200201test_success=0
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700202
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000203test_external_has_tap=0
204
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100205die () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200206 code=$?
207 if test -n "$GIT_EXIT_OK"
208 then
209 exit $code
210 else
211 echo >&5 "FATAL: Unexpected exit with code $code"
212 exit 1
213 fi
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100214}
215
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200216GIT_EXIT_OK=
Markus Heidelberg35641312009-01-20 00:43:26 +0100217trap 'die' EXIT
Pavel Roskin41184272005-08-11 12:00:40 -0400218
Bryan Donlan02b35662008-05-04 01:37:54 -0400219# The semantics of the editor variables are that of invoking
220# sh -c "$EDITOR \"$@\"" files ...
221#
222# If our trash directory contains shell metacharacters, they will be
223# interpreted if we just set $EDITOR directly, so do a little dance with
224# environment variables to work around this.
225#
226# In particular, quoting isn't enough, as the path may contain the same quote
Lea Wiemann7b7b4512008-06-13 00:35:59 +0200227# that we're using.
Bryan Donlan02b35662008-05-04 01:37:54 -0400228test_set_editor () {
229 FAKE_EDITOR="$1"
230 export FAKE_EDITOR
Jonathan Niederd33738d2009-11-11 17:56:07 -0600231 EDITOR='"$FAKE_EDITOR"'
232 export EDITOR
Bryan Donlan02b35662008-05-04 01:37:54 -0400233}
234
Michael J Gruber68cfc6f2009-12-08 11:12:02 +0100235test_decode_color () {
Kevin Ballarda4718332010-10-20 15:17:25 -0700236 awk '
237 function name(n) {
238 if (n == 0) return "RESET";
239 if (n == 1) return "BOLD";
240 if (n == 30) return "BLACK";
241 if (n == 31) return "RED";
242 if (n == 32) return "GREEN";
243 if (n == 33) return "YELLOW";
244 if (n == 34) return "BLUE";
245 if (n == 35) return "MAGENTA";
246 if (n == 36) return "CYAN";
247 if (n == 37) return "WHITE";
248 if (n == 40) return "BLACK";
249 if (n == 41) return "BRED";
250 if (n == 42) return "BGREEN";
251 if (n == 43) return "BYELLOW";
252 if (n == 44) return "BBLUE";
253 if (n == 45) return "BMAGENTA";
254 if (n == 46) return "BCYAN";
255 if (n == 47) return "BWHITE";
256 }
257 {
Brandon Caseyc2ed29b2010-12-22 15:58:52 -0800258 while (match($0, /\033\[[0-9;]*m/) != 0) {
Kevin Ballarda4718332010-10-20 15:17:25 -0700259 printf "%s<", substr($0, 1, RSTART-1);
260 codes = substr($0, RSTART+2, RLENGTH-3);
261 if (length(codes) == 0)
262 printf "%s", name(0)
263 else {
264 n = split(codes, ary, ";");
265 sep = "";
266 for (i = 1; i <= n; i++) {
267 printf "%s%s", sep, name(ary[i]);
268 sep = ";"
269 }
270 }
271 printf ">";
272 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
273 }
274 print
275 }
276 '
Michael J Gruber68cfc6f2009-12-08 11:12:02 +0100277}
278
Jeff King9130ac92010-10-07 14:25:43 -0400279nul_to_q () {
280 perl -pe 'y/\000/Q/'
281}
282
Stephen Boydc4f3f552010-01-25 16:33:57 -0800283q_to_nul () {
284 perl -pe 'y/Q/\000/'
285}
286
287q_to_cr () {
288 tr Q '\015'
289}
290
Jonathan Nieder800f1102010-07-23 12:03:07 -0500291q_to_tab () {
292 tr Q '\011'
293}
294
Stephen Boydc4f3f552010-01-25 16:33:57 -0800295append_cr () {
296 sed -e 's/$/Q/' | tr Q '\015'
297}
298
299remove_cr () {
300 tr '\015' Q | sed -e 's/Q$//'
301}
302
Elijah Newren00648ba2010-10-03 14:00:14 -0600303# In some bourne shell implementations, the "unset" builtin returns
304# nonzero status when a variable to be unset was not set in the first
305# place.
306#
307# Use sane_unset when that should not be considered an error.
308
309sane_unset () {
310 unset "$@"
311 return 0
312}
313
Junio C Hamano04509732006-12-29 02:25:04 -0800314test_tick () {
315 if test -z "${test_tick+set}"
316 then
Junio C Hamano21afc412007-01-06 02:16:07 -0800317 test_tick=1112911993
Junio C Hamano04509732006-12-29 02:25:04 -0800318 else
319 test_tick=$(($test_tick + 60))
320 fi
Junio C Hamano21afc412007-01-06 02:16:07 -0800321 GIT_COMMITTER_DATE="$test_tick -0700"
322 GIT_AUTHOR_DATE="$test_tick -0700"
Junio C Hamano04509732006-12-29 02:25:04 -0800323 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
324}
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700325
Johannes Schindelin00884962009-01-27 23:34:48 +0100326# Call test_commit with the arguments "<message> [<file> [<contents>]]"
327#
328# This will commit a file with the given contents and the given commit
329# message. It will also add a tag with <message> as name.
330#
331# Both <file> and <contents> default to <message>.
332
333test_commit () {
Junio C Hamanoe656fc92009-02-03 21:46:33 -0800334 file=${2:-"$1.t"}
Johannes Schindelin00884962009-01-27 23:34:48 +0100335 echo "${3-$1}" > "$file" &&
336 git add "$file" &&
337 test_tick &&
338 git commit -m "$1" &&
339 git tag "$1"
340}
341
342# Call test_merge with the arguments "<message> <commit>", where <commit>
343# can be a tag pointing to the commit-to-merge.
344
345test_merge () {
346 test_tick &&
347 git merge -m "$1" "$2" &&
348 git tag "$1"
349}
350
Johannes Sixt1f553912009-02-28 21:12:57 +0100351# This function helps systems where core.filemode=false is set.
352# Use it instead of plain 'chmod +x' to set or unset the executable bit
353# of a file in the working directory and add it to the index.
354
355test_chmod () {
356 chmod "$@" &&
357 git update-index --add "--chmod=$@"
358}
359
Johannes Sixta7bb3942009-03-01 21:04:46 +0100360# Use test_set_prereq to tell that a particular prerequisite is available.
361# The prerequisite can later be checked for in two ways:
362#
363# - Explicitly using test_have_prereq.
364#
365# - Implicitly by specifying the prerequisite tag in the calls to
366# test_expect_{success,failure,code}.
367#
368# The single parameter is the prerequisite tag (a simple word, in all
369# capital letters by convention).
370
371test_set_prereq () {
372 satisfied="$satisfied$1 "
373}
374satisfied=" "
375
376test_have_prereq () {
Ævar Arnfjörð Bjarmason93a57242010-08-06 21:19:23 +0000377 # prerequisites can be concatenated with ','
378 save_IFS=$IFS
379 IFS=,
380 set -- $*
381 IFS=$save_IFS
Ævar Arnfjörð Bjarmasonce606532010-08-11 12:04:38 +0000382
383 total_prereq=0
384 ok_prereq=0
385 missing_prereq=
386
Ævar Arnfjörð Bjarmason93a57242010-08-06 21:19:23 +0000387 for prerequisite
388 do
Ævar Arnfjörð Bjarmasonce606532010-08-11 12:04:38 +0000389 total_prereq=$(($total_prereq + 1))
Ævar Arnfjörð Bjarmason93a57242010-08-06 21:19:23 +0000390 case $satisfied in
391 *" $prerequisite "*)
Ævar Arnfjörð Bjarmasonce606532010-08-11 12:04:38 +0000392 ok_prereq=$(($ok_prereq + 1))
393 ;;
Ævar Arnfjörð Bjarmason93a57242010-08-06 21:19:23 +0000394 *)
Ævar Arnfjörð Bjarmasonce606532010-08-11 12:04:38 +0000395 # Keep a list of missing prerequisites
396 if test -z "$missing_prereq"
397 then
398 missing_prereq=$prerequisite
399 else
400 missing_prereq="$prerequisite,$missing_prereq"
401 fi
Ævar Arnfjörð Bjarmason93a57242010-08-06 21:19:23 +0000402 esac
403 done
Ævar Arnfjörð Bjarmasonce606532010-08-11 12:04:38 +0000404
405 test $total_prereq = $ok_prereq
Johannes Sixta7bb3942009-03-01 21:04:46 +0100406}
407
Jonathan Nieder05236a52010-10-17 02:36:58 +0800408test_declared_prereq () {
409 case ",$test_prereq," in
410 *,$1,*)
411 return 0
412 ;;
413 esac
414 return 1
415}
416
Junio C Hamano886856a2005-05-14 00:24:27 -0700417# You are not expected to call test_ok_ and test_failure_ directly, use
418# the text_expect_* functions instead.
419
420test_ok_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100421 test_success=$(($test_success + 1))
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000422 say_color "" "ok $test_count - $@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700423}
424
Junio C Hamano886856a2005-05-14 00:24:27 -0700425test_failure_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100426 test_failure=$(($test_failure + 1))
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000427 say_color error "not ok - $test_count $1"
Junio C Hamanobf0dd8a2005-07-22 19:09:34 -0700428 shift
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000429 echo "$@" | sed -e 's/^/# /'
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200430 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
Junio C Hamano886856a2005-05-14 00:24:27 -0700431}
432
Junio C Hamano41ac4142008-02-01 01:50:53 -0800433test_known_broken_ok_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800434 test_fixed=$(($test_fixed+1))
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000435 say_color "" "ok $test_count - $@ # TODO known breakage"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800436}
437
438test_known_broken_failure_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800439 test_broken=$(($test_broken+1))
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000440 say_color skip "not ok $test_count - $@ # TODO known breakage"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800441}
Junio C Hamano886856a2005-05-14 00:24:27 -0700442
443test_debug () {
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700444 test "$debug" = "" || eval "$1"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700445}
446
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400447test_run_ () {
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500448 test_cleanup=:
Junio C Hamanob5867442011-06-27 11:02:22 -0700449 expecting_failure=$2
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400450 eval >&3 2>&4 "$1"
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500451 eval_ret=$?
Junio C Hamanob5867442011-06-27 11:02:22 -0700452
453 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
454 then
455 eval >&3 2>&4 "$test_cleanup"
456 fi
Ævar Arnfjörð Bjarmason57e15382010-06-24 17:44:47 +0000457 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
458 echo ""
459 fi
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400460 return 0
461}
462
Junio C Hamano04ece592006-12-28 17:58:00 -0800463test_skip () {
Johannes Sixt8586f982009-02-05 21:20:56 +0100464 test_count=$(($test_count+1))
Junio C Hamano04ece592006-12-28 17:58:00 -0800465 to_skip=
466 for skp in $GIT_SKIP_TESTS
467 do
Johannes Sixt8586f982009-02-05 21:20:56 +0100468 case $this_test.$test_count in
Junio C Hamano04ece592006-12-28 17:58:00 -0800469 $skp)
470 to_skip=t
Michael J Gruber47e67d42010-07-12 12:32:18 +0200471 break
Junio C Hamano04ece592006-12-28 17:58:00 -0800472 esac
473 done
Jonathan Nieder05236a52010-10-17 02:36:58 +0800474 if test -z "$to_skip" && test -n "$test_prereq" &&
475 ! test_have_prereq "$test_prereq"
Johannes Sixta7bb3942009-03-01 21:04:46 +0100476 then
477 to_skip=t
478 fi
Junio C Hamano04ece592006-12-28 17:58:00 -0800479 case "$to_skip" in
480 t)
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500481 of_prereq=
Jonathan Nieder05236a52010-10-17 02:36:58 +0800482 if test "$missing_prereq" != "$test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500483 then
Jonathan Nieder05236a52010-10-17 02:36:58 +0800484 of_prereq=" of $test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500485 fi
486
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200487 say_color skip >&3 "skipping test: $@"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500488 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
Junio C Hamano04ece592006-12-28 17:58:00 -0800489 : true
490 ;;
491 *)
492 false
493 ;;
494 esac
495}
496
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700497test_expect_failure () {
Jonathan Nieder05236a52010-10-17 02:36:58 +0800498 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700499 test "$#" = 2 ||
Johannes Sixta7bb3942009-03-01 21:04:46 +0100500 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
Jonathan Nieder05236a52010-10-17 02:36:58 +0800501 export test_prereq
Junio C Hamano04ece592006-12-28 17:58:00 -0800502 if ! test_skip "$@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700503 then
Junio C Hamano41ac4142008-02-01 01:50:53 -0800504 say >&3 "checking known breakage: $2"
Junio C Hamanob5867442011-06-27 11:02:22 -0700505 test_run_ "$2" expecting_failure
Junio C Hamano41ac4142008-02-01 01:50:53 -0800506 if [ "$?" = 0 -a "$eval_ret" = 0 ]
Junio C Hamano04ece592006-12-28 17:58:00 -0800507 then
Junio C Hamano41ac4142008-02-01 01:50:53 -0800508 test_known_broken_ok_ "$1"
Junio C Hamano04ece592006-12-28 17:58:00 -0800509 else
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200510 test_known_broken_failure_ "$1"
Junio C Hamano04ece592006-12-28 17:58:00 -0800511 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700512 fi
Martin Waitz7a0cf2d2006-10-07 21:27:46 +0200513 echo >&3 ""
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700514}
515
516test_expect_success () {
Jonathan Nieder05236a52010-10-17 02:36:58 +0800517 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700518 test "$#" = 2 ||
Johannes Sixta7bb3942009-03-01 21:04:46 +0100519 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
Jonathan Nieder05236a52010-10-17 02:36:58 +0800520 export test_prereq
Junio C Hamano04ece592006-12-28 17:58:00 -0800521 if ! test_skip "$@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700522 then
Junio C Hamano04ece592006-12-28 17:58:00 -0800523 say >&3 "expecting success: $2"
524 test_run_ "$2"
525 if [ "$?" = 0 -a "$eval_ret" = 0 ]
526 then
527 test_ok_ "$1"
528 else
529 test_failure_ "$@"
530 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700531 fi
Martin Waitz7a0cf2d2006-10-07 21:27:46 +0200532 echo >&3 ""
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700533}
534
Lea Wiemannfb32c412008-06-19 20:18:03 +0200535# test_external runs external test scripts that provide continuous
536# test output about their progress, and succeeds/fails on
537# zero/non-zero exit code. It outputs the test output on stdout even
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000538# in non-verbose mode, and announces the external script with "# run
Lea Wiemannfb32c412008-06-19 20:18:03 +0200539# <n>: ..." before running it. When providing relative paths, keep in
540# mind that all scripts run in "trash directory".
541# Usage: test_external description command arguments...
542# Example: test_external 'Perl API' perl ../path/to/test.pl
543test_external () {
Jonathan Nieder05236a52010-10-17 02:36:58 +0800544 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
Johannes Sixta7bb3942009-03-01 21:04:46 +0100545 test "$#" = 3 ||
546 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
Lea Wiemannfb32c412008-06-19 20:18:03 +0200547 descr="$1"
548 shift
Jonathan Nieder05236a52010-10-17 02:36:58 +0800549 export test_prereq
Lea Wiemannfb32c412008-06-19 20:18:03 +0200550 if ! test_skip "$descr" "$@"
551 then
552 # Announce the script to reduce confusion about the
553 # test output that follows.
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000554 say_color "" "# run $test_count: $descr ($*)"
Jakub Narebski5ae80302010-04-24 15:50:09 +0200555 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
556 # to be able to use them in script
557 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
Lea Wiemannfb32c412008-06-19 20:18:03 +0200558 # Run command; redirect its stderr to &4 as in
559 # test_run_, but keep its stdout on our stdout even in
560 # non-verbose mode.
561 "$@" 2>&4
562 if [ "$?" = 0 ]
563 then
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000564 if test $test_external_has_tap -eq 0; then
565 test_ok_ "$descr"
566 else
567 say_color "" "# test_external test $descr was ok"
568 test_success=$(($test_success + 1))
569 fi
Lea Wiemannfb32c412008-06-19 20:18:03 +0200570 else
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000571 if test $test_external_has_tap -eq 0; then
572 test_failure_ "$descr" "$@"
573 else
574 say_color error "# test_external test $descr failed: $@"
575 test_failure=$(($test_failure + 1))
576 fi
Lea Wiemannfb32c412008-06-19 20:18:03 +0200577 fi
578 fi
579}
580
581# Like test_external, but in addition tests that the command generated
582# no output on stderr.
583test_external_without_stderr () {
584 # The temporary file has no (and must have no) security
585 # implications.
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +0200586 tmp=${TMPDIR:-/tmp}
Lea Wiemannfb32c412008-06-19 20:18:03 +0200587 stderr="$tmp/git-external-stderr.$$.tmp"
588 test_external "$@" 4> "$stderr"
589 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
590 descr="no stderr: $1"
591 shift
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000592 say >&3 "# expecting no stderr from previous command"
Lea Wiemannfb32c412008-06-19 20:18:03 +0200593 if [ ! -s "$stderr" ]; then
594 rm "$stderr"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000595
596 if test $test_external_has_tap -eq 0; then
597 test_ok_ "$descr"
598 else
599 say_color "" "# test_external_without_stderr test $descr was ok"
600 test_success=$(($test_success + 1))
601 fi
Lea Wiemannfb32c412008-06-19 20:18:03 +0200602 else
603 if [ "$verbose" = t ]; then
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000604 output=`echo; echo "# Stderr is:"; cat "$stderr"`
Lea Wiemannfb32c412008-06-19 20:18:03 +0200605 else
606 output=
607 fi
608 # rm first in case test_failure exits.
609 rm "$stderr"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000610 if test $test_external_has_tap -eq 0; then
611 test_failure_ "$descr" "$@" "$output"
612 else
613 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
614 test_failure=$(($test_failure + 1))
615 fi
Lea Wiemannfb32c412008-06-19 20:18:03 +0200616 fi
617}
618
Matthieu Moy2caf20c2010-08-10 17:17:52 +0200619# debugging-friendly alternatives to "test [-f|-d|-e]"
620# The commands test the existence or non-existence of $1. $2 can be
621# given to provide a more precise diagnosis.
622test_path_is_file () {
623 if ! [ -f "$1" ]
624 then
625 echo "File $1 doesn't exist. $*"
626 false
627 fi
628}
629
630test_path_is_dir () {
631 if ! [ -d "$1" ]
632 then
633 echo "Directory $1 doesn't exist. $*"
634 false
635 fi
636}
637
638test_path_is_missing () {
639 if [ -e "$1" ]
640 then
641 echo "Path exists:"
642 ls -ld "$1"
643 if [ $# -ge 1 ]; then
644 echo "$*"
645 fi
646 false
647 fi
648}
649
Jonathan Niederfb3340a2010-10-31 02:33:50 -0500650# test_line_count checks that a file has the number of lines it
651# ought to. For example:
652#
653# test_expect_success 'produce exactly one line of output' '
654# do something >output &&
655# test_line_count = 1 output
656# '
657#
658# is like "test $(wc -l <output) = 1" except that it passes the
659# output through when the number of lines is wrong.
660
661test_line_count () {
662 if test $# != 3
663 then
664 error "bug in the test script: not 3 parameters to test_line_count"
665 elif ! test $(wc -l <"$3") "$1" "$2"
666 then
667 echo "test_line_count: line count for $3 !$1 $2"
668 cat "$3"
669 return 1
670 fi
671}
Matthieu Moy2caf20c2010-08-10 17:17:52 +0200672
Junio C Hamano74359822008-02-28 13:09:30 -0800673# This is not among top-level (test_expect_success | test_expect_failure)
674# but is a prefix that can be used in the test script, like:
675#
676# test_expect_success 'complain and die' '
677# do something &&
678# do something else &&
679# test_must_fail git checkout ../outerspace
680# '
681#
682# Writing this as "! git checkout ../outerspace" is wrong, because
683# the failure could be due to a segv. We want a controlled failure.
684
685test_must_fail () {
686 "$@"
Jeff King16034fb2010-08-31 11:56:36 -0400687 exit_code=$?
688 if test $exit_code = 0; then
689 echo >&2 "test_must_fail: command succeeded: $*"
690 return 1
691 elif test $exit_code -gt 129 -a $exit_code -le 192; then
692 echo >&2 "test_must_fail: died by signal: $*"
693 return 1
Jeff Kinga54ce3c2010-08-31 11:56:53 -0400694 elif test $exit_code = 127; then
695 echo >&2 "test_must_fail: command not found: $*"
696 return 1
Jeff King16034fb2010-08-31 11:56:36 -0400697 fi
698 return 0
Junio C Hamano74359822008-02-28 13:09:30 -0800699}
700
Jonathan Niederfdf1bc42010-04-14 19:38:07 -0500701# Similar to test_must_fail, but tolerates success, too. This is
702# meant to be used in contexts like:
703#
704# test_expect_success 'some command works without configuration' '
705# test_might_fail git config --unset all.configuration &&
706# do something
707# '
708#
709# Writing "git config --unset all.configuration || :" would be wrong,
710# because we want to notice if it fails due to segv.
711
712test_might_fail () {
713 "$@"
Jonathan Nieder5c8e1412010-08-31 12:10:55 -0500714 exit_code=$?
715 if test $exit_code -gt 129 -a $exit_code -le 192; then
716 echo >&2 "test_might_fail: died by signal: $*"
717 return 1
Jonathan Niederd0b8a612010-08-31 12:26:57 -0500718 elif test $exit_code = 127; then
719 echo >&2 "test_might_fail: command not found: $*"
720 return 1
Jonathan Nieder5c8e1412010-08-31 12:10:55 -0500721 fi
722 return 0
Jonathan Niederfdf1bc42010-04-14 19:38:07 -0500723}
724
Ævar Arnfjörð Bjarmason892e6f72010-10-03 13:59:59 -0600725# Similar to test_must_fail and test_might_fail, but check that a
726# given command exited with a given exit code. Meant to be used as:
727#
728# test_expect_success 'Merge with d/f conflicts' '
729# test_expect_code 1 git merge "merge msg" B master
730# '
731
732test_expect_code () {
733 want_code=$1
734 shift
735 "$@"
736 exit_code=$?
737 if test $exit_code = $want_code
738 then
Ævar Arnfjörð Bjarmason892e6f72010-10-03 13:59:59 -0600739 return 0
Ævar Arnfjörð Bjarmason892e6f72010-10-03 13:59:59 -0600740 fi
Jonathan Niederf5b7ce12011-05-21 14:40:32 -0500741
742 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
743 return 1
Ævar Arnfjörð Bjarmason892e6f72010-10-03 13:59:59 -0600744}
745
Jeff King82ebb0b2008-03-12 17:36:36 -0400746# test_cmp is a helper function to compare actual and expected output.
747# You can use it like:
748#
749# test_expect_success 'foo works' '
750# echo expected >expected &&
751# foo >actual &&
752# test_cmp expected actual
753# '
754#
755# This could be written as either "cmp" or "diff -u", but:
756# - cmp's output is not nearly as easy to read as diff -u
757# - not all diff versions understand "-u"
758
759test_cmp() {
760 $GIT_TEST_CMP "$@"
761}
762
Jonathan Nieder3bf78862010-05-02 03:53:41 -0500763# This function can be used to schedule some commands to be run
764# unconditionally at the end of the test to restore sanity:
765#
766# test_expect_success 'test core.capslock' '
767# git config core.capslock true &&
768# test_when_finished "git config --unset core.capslock" &&
769# hello world
770# '
771#
772# That would be roughly equivalent to
773#
774# test_expect_success 'test core.capslock' '
775# git config core.capslock true &&
776# hello world
777# git config --unset core.capslock
778# '
779#
780# except that the greeting and config --unset must both succeed for
781# the test to pass.
Junio C Hamanob5867442011-06-27 11:02:22 -0700782#
783# Note that under --immediate mode, no clean-up is done to help diagnose
784# what went wrong.
Jonathan Nieder3bf78862010-05-02 03:53:41 -0500785
786test_when_finished () {
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500787 test_cleanup="{ $*
788 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
Jonathan Nieder3bf78862010-05-02 03:53:41 -0500789}
790
Michele Ballabio0509eb22008-01-31 22:59:11 +0100791# Most tests can use the created repository, but some may need to create more.
Carl Wortheedf8f92006-02-17 13:33:26 -0800792# Usage: test_create_repo <directory>
793test_create_repo () {
794 test "$#" = 1 ||
795 error "bug in the test script: not 1 parameter to test-create-repo"
Carl Wortheedf8f92006-02-17 13:33:26 -0800796 repo="$1"
Junio C Hamanobfdbee92008-08-08 02:26:28 -0700797 mkdir -p "$repo"
Ævar Arnfjörð Bjarmason0d314ce2010-08-30 12:00:42 +0000798 (
799 cd "$repo" || error "Cannot setup test environment"
800 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
801 error "cannot run git init -- have you built things yet?"
802 mv .git/hooks .git/hooks-disabled
803 ) || exit
Carl Wortheedf8f92006-02-17 13:33:26 -0800804}
Junio C Hamanoa6080a02007-06-07 00:04:01 -0700805
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700806test_done () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200807 GIT_EXIT_OK=t
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200808
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000809 if test -z "$HARNESS_ACTIVE"; then
810 test_results_dir="$TEST_DIRECTORY/test-results"
811 mkdir -p "$test_results_dir"
812 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
813
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +0200814 cat >>"$test_results_path" <<-EOF
815 total $test_count
816 success $test_success
817 fixed $test_fixed
818 broken $test_broken
819 failed $test_failure
820
821 EOF
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000822 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -0800823
824 if test "$test_fixed" != 0
825 then
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000826 say_color pass "# fixed $test_fixed known breakage(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800827 fi
828 if test "$test_broken" != 0
829 then
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000830 say_color error "# still have $test_broken known breakage(s)"
Junio C Hamano11d54b82008-02-03 00:23:02 -0800831 msg="remaining $(($test_count-$test_broken)) test(s)"
832 else
833 msg="$test_count test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800834 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700835 case "$test_failure" in
Junio C Hamano10b94e22005-12-09 17:32:18 -0800836 0)
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000837 # Maybe print SKIP message
838 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
839
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000840 if test $test_external_has_tap -eq 0; then
841 say_color pass "# passed all $msg"
842 say "1..$test_count$skip_all"
843 fi
Johannes Schindelinabc5d372008-08-08 13:08:37 +0200844
845 test -d "$remove_trash" &&
846 cd "$(dirname "$remove_trash")" &&
847 rm -rf "$(basename "$remove_trash")"
848
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700849 exit 0 ;;
850
851 *)
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000852 if test $test_external_has_tap -eq 0; then
853 say_color error "# failed $test_failure among $msg"
854 say "1..$test_count"
855 fi
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000856
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700857 exit 1 ;;
858
859 esac
860}
861
862# Test the binaries we have just built. The tests are kept in
Jakub Narebski9adefee2008-06-14 20:14:12 +0200863# t/ subdirectory and are run in 'trash directory' subdirectory.
Ævar Arnfjörð Bjarmason62f53902010-08-19 16:08:11 +0000864if test -z "$TEST_DIRECTORY"
865then
866 # We allow tests to override this, in case they want to run tests
867 # outside of t/, e.g. for running tests on the test library
868 # itself.
869 TEST_DIRECTORY=$(pwd)
870fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000871GIT_BUILD_DIR="$TEST_DIRECTORY"/..
872
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700873if test -n "$valgrind"
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100874then
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100875 make_symlink () {
876 test -h "$2" &&
877 test "$1" = "$(readlink "$2")" || {
878 # be super paranoid
879 if mkdir "$2".lock
880 then
881 rm -f "$2" &&
882 ln -s "$1" "$2" &&
883 rm -r "$2".lock
884 else
885 while test -d "$2".lock
886 do
887 say "Waiting for lock on $2."
888 sleep 1
889 done
890 fi
891 }
892 }
893
894 make_valgrind_symlink () {
Jeff King36bfb0e2011-06-17 16:36:32 -0400895 # handle only executables, unless they are shell libraries that
896 # need to be in the exec-path. We will just use "#!" as a
897 # guess for a shell-script, since we have no idea what the user
898 # may have configured as the shell path.
899 test -x "$1" ||
900 test "#!" = "$(head -c 2 <"$1")" ||
901 return;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100902
903 base=$(basename "$1")
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000904 symlink_target=$GIT_BUILD_DIR/$base
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100905 # do not override scripts
906 if test -x "$symlink_target" &&
907 test ! -d "$symlink_target" &&
908 test "#!" != "$(head -c 2 < "$symlink_target")"
909 then
910 symlink_target=../valgrind.sh
911 fi
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100912 case "$base" in
913 *.sh|*.perl)
914 symlink_target=../unprocessed-script
915 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100916 # create the link, or replace it if it is out of date
917 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
918 }
919
920 # override all git executables in TEST_DIRECTORY/..
921 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
922 mkdir -p "$GIT_VALGRIND"/bin
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000923 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100924 do
925 make_valgrind_symlink $file
926 done
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100927 OLDIFS=$IFS
928 IFS=:
929 for path in $PATH
930 do
931 ls "$path"/git-* 2> /dev/null |
932 while read file
933 do
934 make_valgrind_symlink "$file"
935 done
936 done
937 IFS=$OLDIFS
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100938 PATH=$GIT_VALGRIND/bin:$PATH
939 GIT_EXEC_PATH=$GIT_VALGRIND/bin
940 export GIT_VALGRIND
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700941elif test -n "$GIT_TEST_INSTALLED" ; then
942 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
943 error "Cannot run git from $GIT_TEST_INSTALLED."
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000944 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700945 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
946else # normal case, use ../bin-wrappers only unless $with_dashes:
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000947 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700948 if ! test -x "$git_bin_dir/git" ; then
949 if test -z "$with_dashes" ; then
950 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
951 fi
952 with_dashes=t
953 fi
954 PATH="$git_bin_dir:$PATH"
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000955 GIT_EXEC_PATH=$GIT_BUILD_DIR
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700956 if test -n "$with_dashes" ; then
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000957 PATH="$GIT_BUILD_DIR:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700958 fi
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100959fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000960GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
Jeff King8bfa6bd2008-02-06 05:11:53 -0500961unset GIT_CONFIG
Jeff King8bfa6bd2008-02-06 05:11:53 -0500962GIT_CONFIG_NOSYSTEM=1
Jonathan Nieder3c995be2011-03-15 04:05:10 -0500963GIT_ATTR_NOSYSTEM=1
Jonathan Nieder8f323c02011-03-15 04:04:49 -0500964export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
Junio C Hamano49ccb082005-12-07 21:52:28 -0800965
Ævar Arnfjörð Bjarmasonaed604c2010-08-19 16:08:09 +0000966. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
Jeff Kingac10a852009-12-07 00:32:50 -0500967
Junio C Hamano5e87eae2010-06-11 09:40:25 -0700968if test -z "$GIT_TEST_CMP"
969then
970 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
971 then
972 GIT_TEST_CMP="$DIFF -c"
973 else
974 GIT_TEST_CMP="$DIFF -u"
975 fi
976fi
977
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000978GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
Petr Baudis6fcca932006-07-03 23:16:32 +0200979export GITPERLLIB
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000980test -d "$GIT_BUILD_DIR"/templates/blt || {
Junio C Hamanoeea42062005-12-10 20:55:32 -0800981 error "You haven't built things yet, have you?"
982}
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700983
Jeff Kingac10a852009-12-07 00:32:50 -0500984if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
Sverre Rabbelier2fe40b62009-11-18 02:42:32 +0100985then
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000986 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
Sverre Rabbelier2fe40b62009-11-18 02:42:32 +0100987 export GITPYTHONLIB
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000988 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
Sverre Rabbelier2fe40b62009-11-18 02:42:32 +0100989 error "You haven't built git_remote_helpers yet, have you?"
990 }
991fi
992
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000993if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
Eric Wong56cf9802007-02-24 16:59:52 -0800994 echo >&2 'You need to build test-chmtime:'
995 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
996 exit 1
997fi
998
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700999# Test repository
Johannes Schindelinabc5d372008-08-08 13:08:37 +02001000test="trash directory.$(basename "$0" .sh)"
Jeff Kingf423ef52009-08-09 04:39:45 -04001001test -n "$root" && test="$root/$test"
1002case "$test" in
1003/*) TRASH_DIRECTORY="$test" ;;
1004 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1005esac
Jeff King91c8b822009-08-09 04:38:11 -04001006test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
Junio C Hamano8d14ac92008-03-18 21:58:01 -07001007rm -fr "$test" || {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +02001008 GIT_EXIT_OK=t
Junio C Hamano8d14ac92008-03-18 21:58:01 -07001009 echo >&5 "FATAL: Cannot prepare test area"
1010 exit 1
1011}
1012
Alex Riesen90cff962011-03-26 19:46:34 +01001013HOME="$TRASH_DIRECTORY"
1014export HOME
1015
Bryan Donlan4a7aacc2008-05-04 01:38:00 -04001016test_create_repo "$test"
Lea Wiemann1bd9c642008-05-31 23:11:21 +02001017# Use -P to resolve symlinks in our working directory so that the cwd
1018# in subprocesses like git equals our $PWD (for pathname comparisons).
1019cd -P "$test" || exit 1
Junio C Hamano04ece592006-12-28 17:58:00 -08001020
Johannes Sixtd5d9de12009-02-05 20:59:27 +01001021this_test=${0##*/}
1022this_test=${this_test%%-*}
Junio C Hamano04ece592006-12-28 17:58:00 -08001023for skp in $GIT_SKIP_TESTS
1024do
Michael J Gruber47e67d42010-07-12 12:32:18 +02001025 case "$this_test" in
1026 $skp)
Pierre Habouzit55db1df2007-10-24 22:03:38 +02001027 say_color skip >&3 "skipping test $this_test altogether"
Michael J Gruber637ab292010-07-12 12:33:49 +02001028 skip_all="skip all tests in $this_test"
Junio C Hamano04ece592006-12-28 17:58:00 -08001029 test_done
1030 esac
1031done
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001032
Brandon Casey86487322009-08-28 17:32:41 -05001033# Provide an implementation of the 'yes' utility
1034yes () {
1035 if test $# = 0
1036 then
1037 y=y
1038 else
1039 y="$*"
1040 fi
1041
1042 while echo "$y"
1043 do
1044 :
1045 done
1046}
1047
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001048# Fix some commands on Windows
1049case $(uname -s) in
1050*MINGW*)
1051 # Windows has its own (incompatible) sort and find
1052 sort () {
1053 /usr/bin/sort "$@"
1054 }
1055 find () {
1056 /usr/bin/find "$@"
1057 }
Johannes Sixt5397ea32009-03-14 22:21:27 +01001058 sum () {
1059 md5sum "$@"
1060 }
Johannes Sixt41141562009-03-13 23:35:24 +01001061 # git sees Windows-style pwd
1062 pwd () {
1063 builtin pwd -W
1064 }
Johannes Sixtee9fb682009-03-13 22:55:27 +01001065 # no POSIX permissions
Johannes Sixt6fd11062009-03-13 23:00:15 +01001066 # backslashes in pathspec are converted to '/'
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001067 # exec does not inherit the PID
Pat Thoytsa94114a2010-09-12 10:37:24 +01001068 test_set_prereq MINGW
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001069 test_set_prereq SED_STRIPS_CR
1070 ;;
1071*CYGWIN*)
1072 test_set_prereq POSIXPERM
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001073 test_set_prereq EXECKEEPSPID
1074 test_set_prereq NOT_MINGW
1075 test_set_prereq SED_STRIPS_CR
Johannes Sixtee9fb682009-03-13 22:55:27 +01001076 ;;
1077*)
1078 test_set_prereq POSIXPERM
Johannes Sixt6fd11062009-03-13 23:00:15 +01001079 test_set_prereq BSLASHPSPEC
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001080 test_set_prereq EXECKEEPSPID
Pat Thoyts3ba9ba82010-09-27 22:02:57 +01001081 test_set_prereq NOT_MINGW
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001082 ;;
1083esac
Johannes Sixt704a3142009-03-04 22:38:24 +01001084
Jeff King1b19ccd2009-04-03 15:33:59 -04001085test -z "$NO_PERL" && test_set_prereq PERL
Johan Herlandd4e1b472009-11-18 02:42:31 +01001086test -z "$NO_PYTHON" && test_set_prereq PYTHON
Michał Kiedrowicz8f852ce2011-05-09 23:52:07 +02001087test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
Jeff King1b19ccd2009-04-03 15:33:59 -04001088
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001089# Can we rely on git's output in the C locale?
Jonathan Nieder30955222011-02-22 23:41:22 +00001090if test -n "$GETTEXT_POISON"
1091then
1092 GIT_GETTEXT_POISON=YesPlease
1093 export GIT_GETTEXT_POISON
1094else
1095 test_set_prereq C_LOCALE_OUTPUT
1096fi
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001097
Junio C Hamanocabdee22011-04-12 11:23:23 -07001098# Use this instead of test_cmp to compare files that contain expected and
1099# actual output from git commands that can be translated. When running
1100# under GETTEXT_POISON this pretends that the command produced expected
1101# results.
1102test_i18ncmp () {
1103 test -n "$GETTEXT_POISON" || test_cmp "$@"
1104}
1105
Junio C Hamano127df8c2011-04-12 15:57:08 -07001106# Use this instead of "grep expected-string actual" to see if the
1107# output from a git command that can be translated either contains an
1108# expected string, or does not contain an unwanted one. When running
1109# under GETTEXT_POISON this pretends that the command produced expected
1110# results.
1111test_i18ngrep () {
1112 if test -n "$GETTEXT_POISON"
1113 then
1114 : # pretend success
1115 elif test "x!" = "x$1"
1116 then
1117 shift
1118 ! grep "$@"
1119 else
1120 grep "$@"
1121 fi
1122}
1123
Johannes Sixt704a3142009-03-04 22:38:24 +01001124# test whether the filesystem supports symbolic links
1125ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1126rm -f y
Ævar Arnfjörð Bjarmasonc91cfd12010-08-06 22:09:09 +00001127
1128# When the tests are run as root, permission tests will report that
1129# things are writable when they shouldn't be.
1130test -w / || test_set_prereq SANITY